<template>
	<v-container class="field-show flex-grow-1" :class="{ 'px-0': $vuetify.breakpoint.smAndDown }">
		<v-skeleton-loader v-if="isLoading" type="card" min-height="500px" />
		<v-card v-else-if="hasError" rounded="lg">
			<v-card-text> Error loading field </v-card-text>
		</v-card>
		<v-card v-else-if="field" rounded="lg" class="overflow-hidden">
			<collect-map
				:area="areas[0]"
				:locations="{
					type: 'FeatureCollection',
					features: locations.filter(({ id }) => locationCollections[0].features.includes(id)),
				}"
			/>
			<v-card-title class="d-flex justify-space-between">
				<div>
					{{ field.name }}
				</div>
			</v-card-title>
			<v-card-actions>
				<create-sampling-collection-button
					:fieldId="field.id"
					:locationCollectionId="locationCollections[0] && locationCollections[0].id"
					:draftSamplingCollections="draftSamplingCollections"
				/>
			</v-card-actions>
			<v-card-text>
				<div>
					<div>
						<span class="text-h6"> Details </span>
					</div>
					<div class="font-weight-bold">Address</div>
					<p class="ml-2">
						<field-address :address="field.address" :areas="areas" />
					</p>
					<div class="font-weight-bold">Contact</div>
					<ul v-if="field.contactPoints.length > 0" class="ml-2">
						<field-contact v-for="(contact, i) in field.contactPoints" :key="i" :contact="contact" />
					</ul>
					<ul v-else>
						<li>No contacts yet.</li>
					</ul>
				</div>

				<div v-if="areas" class="font-weight-bold mt-2">Areas</div>
				<ul v-if="areas && areas.length > 0">
					<li v-for="(area, i) in areas" :key="i">
						{{ area.properties.name }}
						<span class="text-caption">({{ area.id }})</span>
					</li>
				</ul>

				<div v-if="stratifications" class="font-weight-bold mt-2">Stratifications</div>
				<ul v-if="stratifications && stratifications.length > 0">
					<li v-for="(stratification, i) in stratifications" :key="i">
						<div v-if="stratification.name">
							{{ stratification.name }}
							<span class="text-caption">({{ stratification.id }})</span>
						</div>
						<div class="text-caption">
							{{ new Date(stratification.dateCreated).toLocaleString() }}
						</div>
					</li>
				</ul>
				<ul v-else>
					<li>No stratifications yet.</li>
				</ul>
			</v-card-text>
		</v-card>
	</v-container>
</template>

<script lang="ts">
import { defineComponent, SetupContext, computed } from '@vue/composition-api';
import CollectMap from '@/components/map/CollectMap.vue';
import { useAllResources } from '@/store/modules/resources';
import { useAllSamplingCollections } from '@/store/modules/samplingCollections';
import FieldAddress from './FieldAddress/FieldAddress.vue';
import FieldContact from './FieldContact/FieldContact.vue';
import CreateSamplingCollectionButton from './CreateSamplingCollectionButton/CreateSamplingCollectionButton.vue';

export default defineComponent({
	components: {
		CollectMap,
		FieldAddress,
		FieldContact,
		CreateSamplingCollectionButton,
	},
	props: {
		id: { type: String, required: true },
	},
	setup(props, { root }: SetupContext) {
		const { isLoading, isLoaded, hasError } = useAllResources(root.$store);
		useAllSamplingCollections(root.$store);
		const field = computed(() => root.$store.getters['resources/getFieldById'](props.id));
		const stratifications = computed(() => root.$store.getters['resources/getStratificationsByFieldId'](props.id));
		const areas = computed(() => root.$store.getters['resources/getAreasByFieldId'](props.id));
		const locationCollections = computed(() =>
			root.$store.getters['resources/getLocationCollectionsByFieldId'](props.id)
		);
		const locations = computed(() => root.$store.getters['resources/getLocationsByFieldId'](props.id));
		const draftSamplingCollections = computed(() => root.$store.getters['samplingCollections/getByFieldId'](props.id));

		return {
			isLoading,
			isLoaded,
			field,
			areas,
			stratifications,
			locationCollections,
			locations,
			hasError,
			draftSamplingCollections,
		};
	},
});
</script>

<style></style>
